
package de.ivu.elect.presentation.gebietsbaum.menu;

import java.util.List;

import javax.inject.Inject;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.gebietsbaum.boundary.GebietConversationStore;
import de.ivu.elect.business.gebietsbaum.entity.GebietConstants;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.gebietsbaum.GebietEditView;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;


import static java.util.Arrays.asList;

public class GebietEditMenuItemEntry extends AbstractGebietMenuItemEntry {

  private static final long serialVersionUID = 1L;

  @Inject
  @ConversationGroup(GebietConversationStore.class)
  private transient GebietConversationStore gebietConversationStore;

  public GebietEditMenuItemEntry() {
    super();
  }

  @Override
  protected UseCasePermission getUseCasePermission() {
    return UseCasePermission.GEBIET_EDIT;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  public String doAction() {
    if (isGebietSelected()) {
      gebietConversationStore.setEntityPK(getSelectedGebiet().getPk());
    }

    return GebietEditView.VIEW_ID;
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return asList(GebietEditView.VIEW_ID);
  }

  @Override
  public String getTargetViewId() {
    return null; // Action ausführen
  }

  @Override
  public String getIcon() {
    return getIcons().getIconEdit();
  }

  @Override
  protected String getLabel() {
    return getMessage(getLabelKey(), getMessage(GebietConstants.MESSAGE_KEY_ENTITY_EINZAHL));
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.menu.item.label";
  }
}
